//*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* Mx4kPlayerDemo.h *#*#*#*#*#*#*# (C) 2014-2015 DekTec
//

#ifndef  __MX4KPLAYERDEMO_H
#define  __MX4KPLAYERDEMO_H

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Include files -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#include <string>
#include <math.h>
#include "DTAPI.h"
#include "MxExamplesCommon.h"

// All code resides in MxExamples namespace
namespace MxExamples
{

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- class Mx4kPlayerDemo -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
//
class Mx4kPlayerDemo : public MxDemoMatrixBase
{
    // Types / Contants
public:
    //-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- CallbackContext -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
    // Context passed to callback function
    struct CallbackContext
    {
        Mx4kPlayerDemo*  m_pPlayer; // Pointer back to the player
        enum
        {
            GEN_VIDEO,
            GEN_AUDIO
        } m_Type;               // Indicates the type off callback to call
    };
    
    // Operations
public:
    virtual bool  Init(DtDevice&  TheCard);
protected:
    bool  PrepCard(DtDevice&  TheCard);
    static void  OnNewFrame(DtMxData* pData, void* pOpaque);
    void  OnGenerateVideo(DtMxData* pData);
    void  OnGenerateAudio(DtMxData* pData);

    // Data / Attributes
public:
protected:
    CallbackContext  m_ContextAudio;  // Context object for audio callback
    CallbackContext  m_ContextVideo;  // Context object for video callback

    MxRectangle  m_BoundingRect;        // Bounding MxRectangle for the image
    std::vector<MxRectangle>  m_Rectangles;  // Floating rectangles
    std::vector<MxToneGenerator>  m_ToneGenerators;  // List of tone generaters for each 
                                                     // audio channel
    
    // Constructor / Destructor
public:
    Mx4kPlayerDemo();
    virtual ~Mx4kPlayerDemo();
};

} // namespace MxExamples

#endif // #ifndef  __MX4KPLAYERDEMO_H
