//#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* MxAncPacketDemo.h *#*#*#*#*#*#*#*#*#* (C) 2017 DekTec
//

#ifndef  __MXAVRECORDERDEMO_H
#define  __MXAVRECORDERDEMO_H

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Include files -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#include "DTAPI.h"
#include "MxExamplesCommon.h"
#include "DtOpt.h"                  // DekTec command line option handler
#include <list>

// All code resides in MxExamples namespace
namespace MxExamples
{

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- class MxAncPacketDemo -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
//
class MxAncPacketDemo : public MxDemoMatrixBase
{
    // Constants / Types
public:

    // Operations
public:
    virtual bool  Init(DtDevice&  TheCard);
    void ParseCommandLine(int argc, char* argv[]);

    // Command-line option getters
    int  CARD_TYPE() const { return m_OptCardType.ToInt(); }
    int  CARD_NO() const { return m_OptCardNo.ToInt(); }
    int  IN_PORT() const { return m_OptInPort.ToInt(); }
    int  IN_VIDSTD() const { return m_OptInVidStd.ToInt(); }
    
protected:
    bool  PrepCard(DtDevice&  TheCard);
    static void  OnNewFrame(DtMxData* pData, void* pOpaque);
    void  OnNewFrame(DtMxData* pData);

    // Data / Attributes
public:
protected:
    // Command-line options
    DtOpt  m_OptCardType;       // -t: Card type (e.g. 2152=DTA-2152)
    DtOpt  m_OptCardNo;         // -n: Card number (0=first, 1=second, ... , etc)
    DtOpt  m_OptInPort;         // -p: Input port 
    DtOpt  m_OptInVidStd;       // -v: input video standard
    DtOpt  m_OptAudMode;        // -a: audio mode 

    // Constructor / Destructor
public:
    MxAncPacketDemo();
    virtual ~MxAncPacketDemo();
};

} // namespace MxExamples

#endif // #ifndef  __MXAVRECORDERDEMO_H
