//*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#* MxFrmBufPlayerDemo.h *#*#*#*#*#*#*#*#* (C) 2015 DekTec
//

#ifndef  __MXFRMPLAYERDEMO_H
#define  __MXFRMPLAYERDEMO_H

//.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- Include files -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
#include <string>
#include <math.h>
#include "DTAPI.h"
#include "MxExamplesCommon.h"
#include "DtOpt.h"                  // DekTec command line option handler

// All code resides in MxExamples namespace
namespace MxExamples
{

//-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.- class MxFrmBufPlayerDemo -.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
//
class MxFrmBufPlayerDemo
{
    // Types / Contants
public:
            
    // Operations
public:
    virtual bool  Init(DtDevice&  TheCard);
    virtual bool  Start();
    virtual void  Stop();
    void ParseCommandLine(int argc, char* argv[]);

    // Command-line option getters
    int  CARD_TYPE() const { return m_OptCardType.ToInt(); }
    int  CARD_NO() const { return m_OptCardNo.ToInt(); }
    int  OUT_PORT() const { return m_OptOutPort.ToInt(); }
    int  OUT_VIDSTD() const { return m_OptOutVidStd.ToInt(); }
    int  GENL_PORT() const { return m_OptGenlPort.ToInt(); }
    int  GENL_VIDSTD() const { return m_OptGenlVidStd.ToInt(); }
        
protected:
    bool  PrepCard(DtDevice&  TheCard);
    static void  ThreadEntry(void*  pContext);
    void  ProcessLoop();
    bool  WriteVideo(__int64  Frame);
    bool  WriteAudio(__int64  Frame);

    // Data / Attributes
public:
protected:
    // Command-line options
    DtOpt  m_OptCardType;           // -t: Card type (e.g. 2152=DTA-2152)
    DtOpt  m_OptCardNo;             // -n: Card number (0=first, 1=second, ... , etc)
    DtOpt  m_OptOutPort;            // -p: Output port 
    DtOpt  m_OptOutVidStd;          // -v: Desired output video standard       
    DtOpt  m_OptGenlPort;           // -gp: Genlock reference port
    DtOpt  m_OptGenlVidStd;         // -gv: Genlock reference video standard

    IMxThread*  m_pTheThread;       // The execution thread
    volatile  bool  m_Exit;         // Exit process loop
    DtFrameBuffer  m_FrmBuf;        // Our frame buffer object

    DtVidStdInfo  m_VidInfo;
        
    // Video buffers
    const int  VIDEO_BUF_SIZE;      // Size of the video buffers
    unsigned char*  m_pBackground;  // Buffer with video back-ground
    unsigned char*  m_pField[2];    // Buffer for fields
    
    // Audio buffer
    unsigned char*  m_pAudio;       // Buffer for audio
    const int  AUDIO_BUF_SIZE;      // Size of audio buffer

    MxRectangle  m_BoundingRect;        // Bounding MxRectangle for the image
    std::vector<MxRectangle>  m_Rectangles;  // Floating rectangles

    // Constructor / Destructor
public:
    MxFrmBufPlayerDemo();
    virtual ~MxFrmBufPlayerDemo();
};

} // namespace MxExamples

#endif // #ifndef  __MXFRMPLAYERDEMO_H
